"use strict";

const ValidationError = require("@validatem/error");
const util = require("util");

module.exports = function (validValues) {
	if (Array.isArray(validValues)) {
		let validValueSet = new Set(validValues);

		return function (value) {
			if (!validValueSet.has(value)) {
				throw new ValidationError(`Must be one of: ${validValues.map((item) => util.inspect(item)).join(", ")}`);
			}
		};
	} else {
		throw new Error("Argument to `oneOf` must be an array of values");
	}
};
